/*!
  * vue-i18n v9.3.0-beta.6
  * (c) 2022 kazuya kawaguchi
  * Released under the MIT License.
  */
import{createVNode,Text,ref,computed,watch,getCurrentInstance,Fragment,h,effectScope,inject,onMounted,onUnmounted,shallowRef,onBeforeMount,isRef}from"vue";const inBrowser="undefined"!=typeof window,hasSymbol="function"==typeof Symbol&&"symbol"==typeof Symbol.toStringTag,makeSymbol=e=>hasSymbol?Symbol(e):e,generateFormatCacheKey=(e,t,a)=>friendlyJSONstringify({l:e,k:t,s:a}),friendlyJSONstringify=e=>JSON.stringify(e).replace(/\u2028/g,"\\u2028").replace(/\u2029/g,"\\u2029").replace(/\u0027/g,"\\u0027"),isNumber=e=>"number"==typeof e&&isFinite(e),isDate=e=>"[object Date]"===toTypeString(e),isRegExp=e=>"[object RegExp]"===toTypeString(e),isEmptyObject=e=>isPlainObject(e)&&0===Object.keys(e).length;function warn(e,t){"undefined"!=typeof console&&(console.warn("[intlify] "+e),t&&console.warn(t.stack))}const assign=Object.assign;function escapeHtml(e){return e.replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&apos;")}const hasOwnProperty=Object.prototype.hasOwnProperty;function hasOwn(e,t){return hasOwnProperty.call(e,t)}const isArray=Array.isArray,isFunction=e=>"function"==typeof e,isString=e=>"string"==typeof e,isBoolean=e=>"boolean"==typeof e,isObject=e=>null!==e&&"object"==typeof e,objectToString=Object.prototype.toString,toTypeString=e=>objectToString.call(e),isPlainObject=e=>"[object Object]"===toTypeString(e),toDisplayString=e=>null==e?"":isArray(e)||isPlainObject(e)&&e.toString===objectToString?JSON.stringify(e,null,2):String(e),CompileErrorCodes={EXPECTED_TOKEN:1,INVALID_TOKEN_IN_PLACEHOLDER:2,UNTERMINATED_SINGLE_QUOTE_IN_PLACEHOLDER:3,UNKNOWN_ESCAPE_SEQUENCE:4,INVALID_UNICODE_ESCAPE_SEQUENCE:5,UNBALANCED_CLOSING_BRACE:6,UNTERMINATED_CLOSING_BRACE:7,EMPTY_PLACEHOLDER:8,NOT_ALLOW_NEST_PLACEHOLDER:9,INVALID_LINKED_FORMAT:10,MUST_HAVE_MESSAGES_IN_PLURAL:11,UNEXPECTED_EMPTY_LINKED_MODIFIER:12,UNEXPECTED_EMPTY_LINKED_KEY:13,UNEXPECTED_LEXICAL_ANALYSIS:14,__EXTEND_POINT__:15};function createCompileError(e,t,a={}){const{domain:r,messages:n,args:l}=a,s=new SyntaxError(String(e));return s.code=e,t&&(s.location=t),s.domain=r,s}const pathStateMachine=[];pathStateMachine[0]={w:[0],i:[3,0],"[":[4],o:[7]},pathStateMachine[1]={w:[1],".":[2],"[":[4],o:[7]},pathStateMachine[2]={w:[2],i:[3,0],0:[3,0]},pathStateMachine[3]={i:[3,0],0:[3,0],w:[1,1],".":[2,1],"[":[4,1],o:[7,1]},pathStateMachine[4]={"'":[5,0],'"':[6,0],"[":[4,2],"]":[1,3],o:8,l:[4,0]},pathStateMachine[5]={"'":[4,0],o:8,l:[5,0]},pathStateMachine[6]={'"':[4,0],o:8,l:[6,0]};const literalValueRE=/^\s?(?:true|false|-?[\d.]+|'[^']*'|"[^"]*")\s?$/;function isLiteral(e){return literalValueRE.test(e)}function stripQuotes(e){const t=e.charCodeAt(0);return t!==e.charCodeAt(e.length-1)||34!==t&&39!==t?e:e.slice(1,-1)}function getPathCharType(e){if(null==e)return"o";switch(e.charCodeAt(0)){case 91:case 93:case 46:case 34:case 39:return e;case 95:case 36:case 45:return"i";case 9:case 10:case 13:case 160:case 65279:case 8232:case 8233:return"w"}return"i"}function formatSubPath(e){const t=e.trim();return("0"!==e.charAt(0)||!isNaN(parseInt(e)))&&(isLiteral(t)?stripQuotes(t):"*"+t)}function parse(e){const t=[];let a,r,n,l,s,o,i,c=-1,u=0,m=0;const g=[];function f(){const t=e[c+1];if(5===u&&"'"===t||6===u&&'"'===t)return c++,n="\\"+t,g[0](),!0}for(g[0]=()=>{void 0===r?r=n:r+=n},g[1]=()=>{void 0!==r&&(t.push(r),r=void 0)},g[2]=()=>{g[0](),m++},g[3]=()=>{if(m>0)m--,u=4,g[0]();else{if(m=0,void 0===r)return!1;if(r=formatSubPath(r),!1===r)return!1;g[1]()}};null!==u;)if(c++,a=e[c],"\\"!==a||!f()){if(l=getPathCharType(a),i=pathStateMachine[u],s=i[l]||i.l||8,8===s)return;if(u=s[0],void 0!==s[1]&&(o=g[s[1]],o&&(n=a,!1===o())))return;if(7===u)return t}}const cache=new Map;function resolveWithKeyValue(e,t){return isObject(e)?e[t]:null}function resolveValue(e,t){if(!isObject(e))return null;let a=cache.get(t);if(a||(a=parse(t),a&&cache.set(t,a)),!a)return null;const r=a.length;let n=e,l=0;for(;l<r;){const e=n[a[l]];if(void 0===e)return null;n=e,l++}return n}const DEFAULT_MODIFIER=e=>e,DEFAULT_MESSAGE=e=>"",DEFAULT_MESSAGE_DATA_TYPE="text",DEFAULT_NORMALIZE=e=>0===e.length?"":e.join(""),DEFAULT_INTERPOLATE=toDisplayString;function pluralDefault(e,t){return e=Math.abs(e),2===t?e?e>1?1:0:1:e?Math.min(e,2):0}function getPluralIndex(e){const t=isNumber(e.pluralIndex)?e.pluralIndex:-1;return e.named&&(isNumber(e.named.count)||isNumber(e.named.n))?isNumber(e.named.count)?e.named.count:isNumber(e.named.n)?e.named.n:t:t}function normalizeNamed(e,t){t.count||(t.count=e),t.n||(t.n=e)}function createMessageContext(e={}){const t=e.locale,a=getPluralIndex(e),r=isObject(e.pluralRules)&&isString(t)&&isFunction(e.pluralRules[t])?e.pluralRules[t]:pluralDefault,n=isObject(e.pluralRules)&&isString(t)&&isFunction(e.pluralRules[t])?pluralDefault:void 0,l=e.list||[],s=e.named||{};isNumber(e.pluralIndex)&&normalizeNamed(a,s);function o(t){const a=isFunction(e.messages)?e.messages(t):!!isObject(e.messages)&&e.messages[t];return a||(e.parent?e.parent.message(t):DEFAULT_MESSAGE)}const i=isPlainObject(e.processor)&&isFunction(e.processor.normalize)?e.processor.normalize:DEFAULT_NORMALIZE,c=isPlainObject(e.processor)&&isFunction(e.processor.interpolate)?e.processor.interpolate:DEFAULT_INTERPOLATE,u={list:e=>l[e],named:e=>s[e],plural:e=>e[r(a,e.length,n)],linked:(t,...a)=>{const[r,n]=a;let l="text",s="";1===a.length?isObject(r)?(s=r.modifier||s,l=r.type||l):isString(r)&&(s=r||s):2===a.length&&(isString(r)&&(s=r||s),isString(n)&&(l=n||l));let i=o(t)(u);return"vnode"===l&&isArray(i)&&s&&(i=i[0]),s?(c=s,e.modifiers?e.modifiers[c]:DEFAULT_MODIFIER)(i,l):i;var c},message:o,type:isPlainObject(e.processor)&&isString(e.processor.type)?e.processor.type:"text",interpolate:c,normalize:i};return u}function fallbackWithSimple(e,t,a){return[...new Set([a,...isArray(t)?t:isObject(t)?Object.keys(t):isString(t)?[t]:[a]])]}function fallbackWithLocaleChain(e,t,a){const r=isString(a)?a:DEFAULT_LOCALE,n=e;n.__localeChainCache||(n.__localeChainCache=new Map);let l=n.__localeChainCache.get(r);if(!l){l=[];let e=[a];for(;isArray(e);)e=appendBlockToChain(l,e,t);const s=isArray(t)||!isPlainObject(t)?t:t.default?t.default:null;e=isString(s)?[s]:s,isArray(e)&&appendBlockToChain(l,e,!1),n.__localeChainCache.set(r,l)}return l}function appendBlockToChain(e,t,a){let r=!0;for(let n=0;n<t.length&&isBoolean(r);n++){const l=t[n];isString(l)&&(r=appendLocaleToChain(e,t[n],a))}return r}function appendLocaleToChain(e,t,a){let r;const n=t.split("-");do{r=appendItemToChain(e,n.join("-"),a),n.splice(-1,1)}while(n.length&&!0===r);return r}function appendItemToChain(e,t,a){let r=!1;if(!e.includes(t)&&(r=!0,t)){r="!"!==t[t.length-1];const n=t.replace(/!/g,"");e.push(n),(isArray(a)||isPlainObject(a))&&a[n]&&(r=a[n])}return r}const VERSION$1="9.3.0-beta.6",NOT_REOSLVED=-1,DEFAULT_LOCALE="en-US",MISSING_RESOLVE_VALUE="",capitalize=e=>`${e.charAt(0).toLocaleUpperCase()}${e.substr(1)}`;function getDefaultLinkedModifiers(){return{upper:(e,t)=>"text"===t&&isString(e)?e.toUpperCase():"vnode"===t&&isObject(e)&&"__v_isVNode"in e?e.children.toUpperCase():e,lower:(e,t)=>"text"===t&&isString(e)?e.toLowerCase():"vnode"===t&&isObject(e)&&"__v_isVNode"in e?e.children.toLowerCase():e,capitalize:(e,t)=>"text"===t&&isString(e)?capitalize(e):"vnode"===t&&isObject(e)&&"__v_isVNode"in e?capitalize(e.children):e}}let _compiler,_resolver,_fallbacker;function registerMessageResolver(e){_resolver=e}function registerLocaleFallbacker(e){_fallbacker=e}let _cid=0;function createCoreContext(e={}){const t=isString(e.version)?e.version:VERSION$1,a=isString(e.locale)?e.locale:DEFAULT_LOCALE,r=isArray(e.fallbackLocale)||isPlainObject(e.fallbackLocale)||isString(e.fallbackLocale)||!1===e.fallbackLocale?e.fallbackLocale:a,n=isPlainObject(e.messages)?e.messages:{[a]:{}},l=isPlainObject(e.datetimeFormats)?e.datetimeFormats:{[a]:{}},s=isPlainObject(e.numberFormats)?e.numberFormats:{[a]:{}},o=assign({},e.modifiers||{},getDefaultLinkedModifiers()),i=e.pluralRules||{},c=isFunction(e.missing)?e.missing:null,u=!isBoolean(e.missingWarn)&&!isRegExp(e.missingWarn)||e.missingWarn,m=!isBoolean(e.fallbackWarn)&&!isRegExp(e.fallbackWarn)||e.fallbackWarn,g=!!e.fallbackFormat,f=!!e.unresolving,p=isFunction(e.postTranslation)?e.postTranslation:null,_=isPlainObject(e.processor)?e.processor:null,b=!isBoolean(e.warnHtmlMessage)||e.warnHtmlMessage,d=!!e.escapeParameter,E=isFunction(e.messageCompiler)?e.messageCompiler:_compiler,v=isFunction(e.messageResolver)?e.messageResolver:_resolver||resolveWithKeyValue,O=isFunction(e.localeFallbacker)?e.localeFallbacker:_fallbacker||fallbackWithSimple,F=isObject(e.fallbackContext)?e.fallbackContext:void 0,I=isFunction(e.onWarn)?e.onWarn:warn,N=e,T=isObject(N.__datetimeFormatters)?N.__datetimeFormatters:new Map,h=isObject(N.__numberFormatters)?N.__numberFormatters:new Map,S=isObject(N.__meta)?N.__meta:{};_cid++;const y={version:t,cid:_cid,locale:a,fallbackLocale:r,messages:n,modifiers:o,pluralRules:i,missing:c,missingWarn:u,fallbackWarn:m,fallbackFormat:g,unresolving:f,postTranslation:p,processor:_,warnHtmlMessage:b,escapeParameter:d,messageCompiler:E,messageResolver:v,localeFallbacker:O,fallbackContext:F,onWarn:I,__meta:S};return y.datetimeFormats=l,y.numberFormats=s,y.__datetimeFormatters=T,y.__numberFormatters=h,y}function handleMissing(e,t,a,r,n){const{missing:l,onWarn:s}=e;if(null!==l){const r=l(e,a,t,n);return isString(r)?r:t}return t}function updateFallbackLocale(e,t,a){e.__localeChainCache=new Map,e.localeFallbacker(e,a,t)}let code$1=CompileErrorCodes.__EXTEND_POINT__;const inc$1=()=>++code$1,CoreErrorCodes={INVALID_ARGUMENT:code$1,INVALID_DATE_ARGUMENT:inc$1(),INVALID_ISO_DATE_ARGUMENT:inc$1(),__EXTEND_POINT__:inc$1()},NOOP_MESSAGE_FUNCTION=()=>"",isMessageFunction=e=>isFunction(e);function translate(e,...t){const{fallbackFormat:a,postTranslation:r,unresolving:n,messageCompiler:l,fallbackLocale:s,messages:o}=e,[i,c]=parseTranslateArgs(...t),u=isBoolean(c.missingWarn)?c.missingWarn:e.missingWarn,m=isBoolean(c.fallbackWarn)?c.fallbackWarn:e.fallbackWarn,g=isBoolean(c.escapeParameter)?c.escapeParameter:e.escapeParameter,f=!!c.resolvedMessage,p=isString(c.default)||isBoolean(c.default)?isBoolean(c.default)?l?i:()=>i:c.default:a?l?i:()=>i:"",_=a||""!==p,b=isString(c.locale)?c.locale:e.locale;g&&escapeParams(c);let[d,E,v]=f?[i,b,o[b]||{}]:resolveMessageFormat(e,i,b,s,m,u),O=d,F=i;if(f||isString(O)||isMessageFunction(O)||_&&(O=p,F=O),!(f||(isString(O)||isMessageFunction(O))&&isString(E)))return n?-1:i;let I=!1;const N=isMessageFunction(O)?O:compileMessageFormat(e,i,E,O,F,(()=>{I=!0}));if(I)return O;const T=evaluateMessage(e,N,createMessageContext(getMessageContextOptions(e,E,v,c)));return r?r(T,i):T}function escapeParams(e){isArray(e.list)?e.list=e.list.map((e=>isString(e)?escapeHtml(e):e)):isObject(e.named)&&Object.keys(e.named).forEach((t=>{isString(e.named[t])&&(e.named[t]=escapeHtml(e.named[t]))}))}function resolveMessageFormat(e,t,a,r,n,l){const{messages:s,onWarn:o,messageResolver:i,localeFallbacker:c}=e,u=c(e,r,a);let m,g={},f=null;for(let a=0;a<u.length&&(m=u[a],g=s[m]||{},null===(f=i(g,t))&&(f=g[t]),!isString(f)&&!isFunction(f));a++){const a=handleMissing(e,t,m,l,"translate");a!==t&&(f=a)}return[f,m,g]}function compileMessageFormat(e,t,a,r,n,l){const{messageCompiler:s,warnHtmlMessage:o}=e;if(isMessageFunction(r)){const e=r;return e.locale=e.locale||a,e.key=e.key||t,e}if(null==s){const e=()=>r;return e.locale=a,e.key=t,e}const i=s(r,getCompileOptions(e,a,n,r,o,l));return i.locale=a,i.key=t,i.source=r,i}function evaluateMessage(e,t,a){return t(a)}function parseTranslateArgs(...e){const[t,a,r]=e,n={};if(!isString(t)&&!isNumber(t)&&!isMessageFunction(t))throw Error(CoreErrorCodes.INVALID_ARGUMENT);const l=isNumber(t)?String(t):(isMessageFunction(t),t);return isNumber(a)?n.plural=a:isString(a)?n.default=a:isPlainObject(a)&&!isEmptyObject(a)?n.named=a:isArray(a)&&(n.list=a),isNumber(r)?n.plural=r:isString(r)?n.default=r:isPlainObject(r)&&assign(n,r),[l,n]}function getCompileOptions(e,t,a,r,n,l){return{warnHtmlMessage:n,onError:e=>{throw l&&l(e),e},onCacheKey:e=>generateFormatCacheKey(t,a,e)}}function getMessageContextOptions(e,t,a,r){const{modifiers:n,pluralRules:l,messageResolver:s,fallbackLocale:o,fallbackWarn:i,missingWarn:c,fallbackContext:u}=e,m={locale:t,modifiers:n,pluralRules:l,messages:r=>{let n=s(a,r);if(null==n&&u){const[,,e]=resolveMessageFormat(u,r,t,o,i,c);n=s(e,r)}if(isString(n)){let a=!1;const l=compileMessageFormat(e,r,t,n,r,(()=>{a=!0}));return a?NOOP_MESSAGE_FUNCTION:l}return isMessageFunction(n)?n:NOOP_MESSAGE_FUNCTION}};return e.processor&&(m.processor=e.processor),r.list&&(m.list=r.list),r.named&&(m.named=r.named),isNumber(r.plural)&&(m.pluralIndex=r.plural),m}function datetime(e,...t){const{datetimeFormats:a,unresolving:r,fallbackLocale:n,onWarn:l,localeFallbacker:s}=e,{__datetimeFormatters:o}=e,[i,c,u,m]=parseDateTimeArgs(...t),g=isBoolean(u.missingWarn)?u.missingWarn:e.missingWarn;isBoolean(u.fallbackWarn)?u.fallbackWarn:e.fallbackWarn;const f=!!u.part,p=isString(u.locale)?u.locale:e.locale,_=s(e,n,p);if(!isString(i)||""===i)return new Intl.DateTimeFormat(p,m).format(c);let b,d={},E=null;for(let t=0;t<_.length&&(b=_[t],d=a[b]||{},E=d[i],!isPlainObject(E));t++)handleMissing(e,i,b,g,"datetime format");if(!isPlainObject(E)||!isString(b))return r?-1:i;let v=`${b}__${i}`;isEmptyObject(m)||(v=`${v}__${JSON.stringify(m)}`);let O=o.get(v);return O||(O=new Intl.DateTimeFormat(b,assign({},E,m)),o.set(v,O)),f?O.formatToParts(c):O.format(c)}const DATETIME_FORMAT_OPTIONS_KEYS=["localeMatcher","weekday","era","year","month","day","hour","minute","second","timeZoneName","formatMatcher","hour12","timeZone","dateStyle","timeStyle","calendar","dayPeriod","numberingSystem","hourCycle","fractionalSecondDigits"];function parseDateTimeArgs(...e){const[t,a,r,n]=e,l={};let s,o={};if(isString(t)){const e=t.match(/(\d{4}-\d{2}-\d{2})(T|\s)?(.*)/);if(!e)throw Error(CoreErrorCodes.INVALID_ISO_DATE_ARGUMENT);const a=e[3]?e[3].trim().startsWith("T")?`${e[1].trim()}${e[3].trim()}`:`${e[1].trim()}T${e[3].trim()}`:e[1].trim();s=new Date(a);try{s.toISOString()}catch(e){throw Error(CoreErrorCodes.INVALID_ISO_DATE_ARGUMENT)}}else if("[object Date]"===toTypeString(t)){if(isNaN(t.getTime()))throw Error(CoreErrorCodes.INVALID_DATE_ARGUMENT);s=t}else{if(!isNumber(t))throw Error(CoreErrorCodes.INVALID_ARGUMENT);s=t}return isString(a)?l.key=a:isPlainObject(a)&&Object.keys(a).forEach((e=>{DATETIME_FORMAT_OPTIONS_KEYS.includes(e)?o[e]=a[e]:l[e]=a[e]})),isString(r)?l.locale=r:isPlainObject(r)&&(o=r),isPlainObject(n)&&(o=n),[l.key||"",s,l,o]}function clearDateTimeFormat(e,t,a){const r=e;for(const e in a){const a=`${t}__${e}`;r.__datetimeFormatters.has(a)&&r.__datetimeFormatters.delete(a)}}function number(e,...t){const{numberFormats:a,unresolving:r,fallbackLocale:n,onWarn:l,localeFallbacker:s}=e,{__numberFormatters:o}=e,[i,c,u,m]=parseNumberArgs(...t),g=isBoolean(u.missingWarn)?u.missingWarn:e.missingWarn;isBoolean(u.fallbackWarn)?u.fallbackWarn:e.fallbackWarn;const f=!!u.part,p=isString(u.locale)?u.locale:e.locale,_=s(e,n,p);if(!isString(i)||""===i)return new Intl.NumberFormat(p,m).format(c);let b,d={},E=null;for(let t=0;t<_.length&&(b=_[t],d=a[b]||{},E=d[i],!isPlainObject(E));t++)handleMissing(e,i,b,g,"number format");if(!isPlainObject(E)||!isString(b))return r?-1:i;let v=`${b}__${i}`;isEmptyObject(m)||(v=`${v}__${JSON.stringify(m)}`);let O=o.get(v);return O||(O=new Intl.NumberFormat(b,assign({},E,m)),o.set(v,O)),f?O.formatToParts(c):O.format(c)}const NUMBER_FORMAT_OPTIONS_KEYS=["localeMatcher","style","currency","currencyDisplay","currencySign","useGrouping","minimumIntegerDigits","minimumFractionDigits","maximumFractionDigits","minimumSignificantDigits","maximumSignificantDigits","compactDisplay","notation","signDisplay","unit","unitDisplay","roundingMode","roundingPriority","roundingIncrement","trailingZeroDisplay"];function parseNumberArgs(...e){const[t,a,r,n]=e,l={};let s={};if(!isNumber(t))throw Error(CoreErrorCodes.INVALID_ARGUMENT);const o=t;return isString(a)?l.key=a:isPlainObject(a)&&Object.keys(a).forEach((e=>{NUMBER_FORMAT_OPTIONS_KEYS.includes(e)?s[e]=a[e]:l[e]=a[e]})),isString(r)?l.locale=r:isPlainObject(r)&&(s=r),isPlainObject(n)&&(s=n),[l.key||"",o,l,s]}function clearNumberFormat(e,t,a){const r=e;for(const e in a){const a=`${t}__${e}`;r.__numberFormatters.has(a)&&r.__numberFormatters.delete(a)}}const VERSION="9.3.0-beta.6";let code=CompileErrorCodes.__EXTEND_POINT__;const inc=()=>++code,I18nErrorCodes={UNEXPECTED_RETURN_TYPE:code,INVALID_ARGUMENT:inc(),MUST_BE_CALL_SETUP_TOP:inc(),NOT_INSLALLED:inc(),NOT_AVAILABLE_IN_LEGACY_MODE:inc(),REQUIRED_VALUE:inc(),INVALID_VALUE:inc(),CANNOT_SETUP_VUE_DEVTOOLS_PLUGIN:inc(),NOT_INSLALLED_WITH_PROVIDE:inc(),UNEXPECTED_ERROR:inc(),NOT_COMPATIBLE_LEGACY_VUE_I18N:inc(),BRIDGE_SUPPORT_VUE_2_ONLY:inc(),MUST_DEFINE_I18N_OPTION_IN_ALLOW_COMPOSITION:inc(),NOT_AVAILABLE_COMPOSITION_IN_LEGACY:inc(),__EXTEND_POINT__:inc()};function createI18nError(e,...t){return createCompileError(e,null,void 0)}const TransrateVNodeSymbol=makeSymbol("__transrateVNode"),DatetimePartsSymbol=makeSymbol("__datetimeParts"),NumberPartsSymbol=makeSymbol("__numberParts"),SetPluralRulesSymbol=makeSymbol("__setPluralRules"),InejctWithOption=makeSymbol("__injectWithOption"),__VUE_I18N_BRIDGE__="__VUE_I18N_BRIDGE__";function handleFlatJson(e){if(!isObject(e))return e;for(const t in e)if(hasOwn(e,t))if(t.includes(".")){const a=t.split("."),r=a.length-1;let n=e;for(let e=0;e<r;e++)a[e]in n||(n[a[e]]={}),n=n[a[e]];n[a[r]]=e[t],delete e[t],isObject(n[a[r]])&&handleFlatJson(n[a[r]])}else isObject(e[t])&&handleFlatJson(e[t]);return e}function getLocaleMessages(e,t){const{messages:a,__i18n:r,messageResolver:n,flatJson:l}=t,s=isPlainObject(a)?a:isArray(r)?{}:{[e]:{}};if(isArray(r)&&r.forEach((e=>{if("locale"in e&&"resource"in e){const{locale:t,resource:a}=e;t?(s[t]=s[t]||{},deepCopy(a,s[t])):deepCopy(a,s)}else isString(e)&&deepCopy(JSON.parse(e),s)})),null==n&&l)for(const e in s)hasOwn(s,e)&&handleFlatJson(s[e]);return s}const isNotObjectOrIsArray=e=>!isObject(e)||isArray(e);function deepCopy(e,t){if(isNotObjectOrIsArray(e)||isNotObjectOrIsArray(t))throw Error(I18nErrorCodes.INVALID_VALUE);for(const a in e)hasOwn(e,a)&&(isNotObjectOrIsArray(e[a])||isNotObjectOrIsArray(t[a])?t[a]=e[a]:deepCopy(e[a],t[a]))}function getComponentOptions(e){return e.type}function adjustI18nResources(e,t,a){let r=isObject(t.messages)?t.messages:{};"__i18nGlobal"in a&&(r=getLocaleMessages(e.locale.value,{messages:r,__i18n:a.__i18nGlobal}));const n=Object.keys(r);if(n.length&&n.forEach((t=>{e.mergeLocaleMessage(t,r[t])})),isObject(t.datetimeFormats)){const a=Object.keys(t.datetimeFormats);a.length&&a.forEach((a=>{e.mergeDateTimeFormat(a,t.datetimeFormats[a])}))}if(isObject(t.numberFormats)){const a=Object.keys(t.numberFormats);a.length&&a.forEach((a=>{e.mergeNumberFormat(a,t.numberFormats[a])}))}}function createTextNode(e){return createVNode(Text,null,e,0)}let composerID=0;function defineCoreMissingHandler(e){return(t,a,r,n)=>e(a,r,getCurrentInstance()||void 0,n)}function createComposer(e={},t){const{__root:a}=e,r=void 0===a;let n=!isBoolean(e.inheritLocale)||e.inheritLocale;const l=ref(a&&n?a.locale.value:isString(e.locale)?e.locale:DEFAULT_LOCALE),s=ref(a&&n?a.fallbackLocale.value:isString(e.fallbackLocale)||isArray(e.fallbackLocale)||isPlainObject(e.fallbackLocale)||!1===e.fallbackLocale?e.fallbackLocale:l.value),o=ref(getLocaleMessages(l.value,e)),i=ref(isPlainObject(e.datetimeFormats)?e.datetimeFormats:{[l.value]:{}}),c=ref(isPlainObject(e.numberFormats)?e.numberFormats:{[l.value]:{}});let u=a?a.missingWarn:!isBoolean(e.missingWarn)&&!isRegExp(e.missingWarn)||e.missingWarn,m=a?a.fallbackWarn:!isBoolean(e.fallbackWarn)&&!isRegExp(e.fallbackWarn)||e.fallbackWarn,g=a?a.fallbackRoot:!isBoolean(e.fallbackRoot)||e.fallbackRoot,f=!!e.fallbackFormat,p=isFunction(e.missing)?e.missing:null,_=isFunction(e.missing)?defineCoreMissingHandler(e.missing):null,b=isFunction(e.postTranslation)?e.postTranslation:null,d=a?a.warnHtmlMessage:!isBoolean(e.warnHtmlMessage)||e.warnHtmlMessage,E=!!e.escapeParameter;const v=a?a.modifiers:isPlainObject(e.modifiers)?e.modifiers:{};let O,F=e.pluralRules||a&&a.pluralRules;O=(()=>{const t={version:VERSION,locale:l.value,fallbackLocale:s.value,messages:o.value,modifiers:v,pluralRules:F,missing:null===_?void 0:_,missingWarn:u,fallbackWarn:m,fallbackFormat:f,unresolving:!0,postTranslation:null===b?void 0:b,warnHtmlMessage:d,escapeParameter:E,messageResolver:e.messageResolver,__meta:{framework:"vue"}};t.datetimeFormats=i.value,t.numberFormats=c.value,t.__datetimeFormatters=isPlainObject(O)?O.__datetimeFormatters:void 0,t.__numberFormatters=isPlainObject(O)?O.__numberFormatters:void 0;return createCoreContext(t)})(),updateFallbackLocale(O,l.value,s.value);const I=computed({get:()=>l.value,set:e=>{l.value=e,O.locale=l.value}}),N=computed({get:()=>s.value,set:e=>{s.value=e,O.fallbackLocale=s.value,updateFallbackLocale(O,l.value,e)}}),T=computed((()=>o.value)),h=computed((()=>i.value)),S=computed((()=>c.value));const y=(e,t,r,n,u,m)=>{let f;if(l.value,s.value,o.value,i.value,c.value,f=e(O),isNumber(f)&&-1===f){const[e,r]=t();return a&&g?n(a):u(e)}if(m(f))return f;throw Error(I18nErrorCodes.UNEXPECTED_RETURN_TYPE)};function L(...e){return y((t=>Reflect.apply(translate,null,[t,...e])),(()=>parseTranslateArgs(...e)),0,(t=>Reflect.apply(t.t,t,[...e])),(e=>e),(e=>isString(e)))}const k={normalize:function(e){return e.map((e=>isString(e)||isNumber(e)||isBoolean(e)?createTextNode(String(e)):e))},interpolate:e=>e,type:"vnode"};function C(e){return o.value[e]||{}}composerID++,a&&inBrowser&&(watch(a.locale,(e=>{n&&(l.value=e,O.locale=e,updateFallbackLocale(O,l.value,s.value))})),watch(a.fallbackLocale,(e=>{n&&(s.value=e,O.fallbackLocale=e,updateFallbackLocale(O,l.value,s.value))})));const M={id:composerID,locale:I,fallbackLocale:N,get inheritLocale(){return n},set inheritLocale(e){n=e,e&&a&&(l.value=a.locale.value,s.value=a.fallbackLocale.value,updateFallbackLocale(O,l.value,s.value))},get availableLocales(){return Object.keys(o.value).sort()},messages:T,get modifiers(){return v},get pluralRules(){return F||{}},get isGlobal(){return r},get missingWarn(){return u},set missingWarn(e){u=e,O.missingWarn=u},get fallbackWarn(){return m},set fallbackWarn(e){m=e,O.fallbackWarn=m},get fallbackRoot(){return g},set fallbackRoot(e){g=e},get fallbackFormat(){return f},set fallbackFormat(e){f=e,O.fallbackFormat=f},get warnHtmlMessage(){return d},set warnHtmlMessage(e){d=e,O.warnHtmlMessage=e},get escapeParameter(){return E},set escapeParameter(e){E=e,O.escapeParameter=e},t:L,getLocaleMessage:C,setLocaleMessage:function(e,t){o.value[e]=t,O.messages=o.value},mergeLocaleMessage:function(e,t){o.value[e]=o.value[e]||{},deepCopy(t,o.value[e]),O.messages=o.value},getPostTranslationHandler:function(){return isFunction(b)?b:null},setPostTranslationHandler:function(e){b=e,O.postTranslation=e},getMissingHandler:function(){return p},setMissingHandler:function(e){null!==e&&(_=defineCoreMissingHandler(e)),p=e,O.missing=_},[SetPluralRulesSymbol]:function(e){F=e,O.pluralRules=F}};return M.datetimeFormats=h,M.numberFormats=S,M.rt=function(...e){const[t,a,r]=e;if(r&&!isObject(r))throw Error(I18nErrorCodes.INVALID_ARGUMENT);return L(t,a,assign({resolvedMessage:!0},r||{}))},M.te=function(e,t){const a=C(isString(t)?t:l.value);return null!==O.messageResolver(a,e)},M.tm=function(e){const t=function(e){let t=null;const a=fallbackWithLocaleChain(O,s.value,l.value);for(let r=0;r<a.length;r++){const n=o.value[a[r]]||{},l=O.messageResolver(n,e);if(null!=l){t=l;break}}return t}(e);return null!=t?t:a&&a.tm(e)||{}},M.d=function(...e){return y((t=>Reflect.apply(datetime,null,[t,...e])),(()=>parseDateTimeArgs(...e)),0,(t=>Reflect.apply(t.d,t,[...e])),(()=>""),(e=>isString(e)))},M.n=function(...e){return y((t=>Reflect.apply(number,null,[t,...e])),(()=>parseNumberArgs(...e)),0,(t=>Reflect.apply(t.n,t,[...e])),(()=>""),(e=>isString(e)))},M.getDateTimeFormat=function(e){return i.value[e]||{}},M.setDateTimeFormat=function(e,t){i.value[e]=t,O.datetimeFormats=i.value,clearDateTimeFormat(O,e,t)},M.mergeDateTimeFormat=function(e,t){i.value[e]=assign(i.value[e]||{},t),O.datetimeFormats=i.value,clearDateTimeFormat(O,e,t)},M.getNumberFormat=function(e){return c.value[e]||{}},M.setNumberFormat=function(e,t){c.value[e]=t,O.numberFormats=c.value,clearNumberFormat(O,e,t)},M.mergeNumberFormat=function(e,t){c.value[e]=assign(c.value[e]||{},t),O.numberFormats=c.value,clearNumberFormat(O,e,t)},M[InejctWithOption]=e.__injectWithOption,M[TransrateVNodeSymbol]=function(...e){return y((t=>{let a;const r=t;try{r.processor=k,a=Reflect.apply(translate,null,[r,...e])}finally{r.processor=null}return a}),(()=>parseTranslateArgs(...e)),0,(t=>t[TransrateVNodeSymbol](...e)),(e=>[createTextNode(e)]),(e=>isArray(e)))},M[DatetimePartsSymbol]=function(...e){return y((t=>Reflect.apply(datetime,null,[t,...e])),(()=>parseDateTimeArgs(...e)),0,(t=>t[DatetimePartsSymbol](...e)),(()=>[]),(e=>isString(e)||isArray(e)))},M[NumberPartsSymbol]=function(...e){return y((t=>Reflect.apply(number,null,[t,...e])),(()=>parseNumberArgs(...e)),0,(t=>t[NumberPartsSymbol](...e)),(()=>[]),(e=>isString(e)||isArray(e)))},M}function convertComposerOptions(e){const t=isString(e.locale)?e.locale:DEFAULT_LOCALE,a=isString(e.fallbackLocale)||isArray(e.fallbackLocale)||isPlainObject(e.fallbackLocale)||!1===e.fallbackLocale?e.fallbackLocale:t,r=isFunction(e.missing)?e.missing:void 0,n=!isBoolean(e.silentTranslationWarn)&&!isRegExp(e.silentTranslationWarn)||!e.silentTranslationWarn,l=!isBoolean(e.silentFallbackWarn)&&!isRegExp(e.silentFallbackWarn)||!e.silentFallbackWarn,s=!isBoolean(e.fallbackRoot)||e.fallbackRoot,o=!!e.formatFallbackMessages,i=isPlainObject(e.modifiers)?e.modifiers:{},c=e.pluralizationRules,u=isFunction(e.postTranslation)?e.postTranslation:void 0,m=!isString(e.warnHtmlInMessage)||"off"!==e.warnHtmlInMessage,g=!!e.escapeParameterHtml,f=!isBoolean(e.sync)||e.sync;let p=e.messages;if(isPlainObject(e.sharedMessages)){const t=e.sharedMessages;p=Object.keys(t).reduce(((e,a)=>{const r=e[a]||(e[a]={});return assign(r,t[a]),e}),p||{})}const{__i18n:_,__root:b,__injectWithOption:d}=e,E=e.datetimeFormats,v=e.numberFormats;return{locale:t,fallbackLocale:a,messages:p,flatJson:e.flatJson,datetimeFormats:E,numberFormats:v,missing:r,missingWarn:n,fallbackWarn:l,fallbackRoot:s,fallbackFormat:o,modifiers:i,pluralRules:c,postTranslation:u,warnHtmlMessage:m,escapeParameter:g,messageResolver:e.messageResolver,inheritLocale:f,__i18n:_,__root:b,__injectWithOption:d}}function createVueI18n(e={},t){{const t=createComposer(convertComposerOptions(e)),a={id:t.id,get locale(){return t.locale.value},set locale(e){t.locale.value=e},get fallbackLocale(){return t.fallbackLocale.value},set fallbackLocale(e){t.fallbackLocale.value=e},get messages(){return t.messages.value},get datetimeFormats(){return t.datetimeFormats.value},get numberFormats(){return t.numberFormats.value},get availableLocales(){return t.availableLocales},get formatter(){return{interpolate:()=>[]}},set formatter(e){},get missing(){return t.getMissingHandler()},set missing(e){t.setMissingHandler(e)},get silentTranslationWarn(){return isBoolean(t.missingWarn)?!t.missingWarn:t.missingWarn},set silentTranslationWarn(e){t.missingWarn=isBoolean(e)?!e:e},get silentFallbackWarn(){return isBoolean(t.fallbackWarn)?!t.fallbackWarn:t.fallbackWarn},set silentFallbackWarn(e){t.fallbackWarn=isBoolean(e)?!e:e},get modifiers(){return t.modifiers},get formatFallbackMessages(){return t.fallbackFormat},set formatFallbackMessages(e){t.fallbackFormat=e},get postTranslation(){return t.getPostTranslationHandler()},set postTranslation(e){t.setPostTranslationHandler(e)},get sync(){return t.inheritLocale},set sync(e){t.inheritLocale=e},get warnHtmlInMessage(){return t.warnHtmlMessage?"warn":"off"},set warnHtmlInMessage(e){t.warnHtmlMessage="off"!==e},get escapeParameterHtml(){return t.escapeParameter},set escapeParameterHtml(e){t.escapeParameter=e},get preserveDirectiveContent(){return!0},set preserveDirectiveContent(e){},get pluralizationRules(){return t.pluralRules||{}},__composer:t,t(...e){const[a,r,n]=e,l={};let s=null,o=null;if(!isString(a))throw Error(I18nErrorCodes.INVALID_ARGUMENT);const i=a;return isString(r)?l.locale=r:isArray(r)?s=r:isPlainObject(r)&&(o=r),isArray(n)?s=n:isPlainObject(n)&&(o=n),Reflect.apply(t.t,t,[i,s||o||{},l])},rt:(...e)=>Reflect.apply(t.rt,t,[...e]),tc(...e){const[a,r,n]=e,l={plural:1};let s=null,o=null;if(!isString(a))throw Error(I18nErrorCodes.INVALID_ARGUMENT);const i=a;return isString(r)?l.locale=r:isNumber(r)?l.plural=r:isArray(r)?s=r:isPlainObject(r)&&(o=r),isString(n)?l.locale=n:isArray(n)?s=n:isPlainObject(n)&&(o=n),Reflect.apply(t.t,t,[i,s||o||{},l])},te:(e,a)=>t.te(e,a),tm:e=>t.tm(e),getLocaleMessage:e=>t.getLocaleMessage(e),setLocaleMessage(e,a){t.setLocaleMessage(e,a)},mergeLocaleMessage(e,a){t.mergeLocaleMessage(e,a)},d:(...e)=>Reflect.apply(t.d,t,[...e]),getDateTimeFormat:e=>t.getDateTimeFormat(e),setDateTimeFormat(e,a){t.setDateTimeFormat(e,a)},mergeDateTimeFormat(e,a){t.mergeDateTimeFormat(e,a)},n:(...e)=>Reflect.apply(t.n,t,[...e]),getNumberFormat:e=>t.getNumberFormat(e),setNumberFormat(e,a){t.setNumberFormat(e,a)},mergeNumberFormat(e,a){t.mergeNumberFormat(e,a)},getChoiceIndex:(e,t)=>-1,__onComponentInstanceCreated(t){const{componentInstanceCreatedListener:r}=e;r&&r(t,a)}};return a}}const baseFormatProps={tag:{type:[String,Object]},locale:{type:String},scope:{type:String,validator:e=>"parent"===e||"global"===e,default:"parent"},i18n:{type:Object}};function getInterpolateArg({slots:e},t){if(1===t.length&&"default"===t[0]){return(e.default?e.default():[]).reduce(((e,t)=>[...e,...t.type===Fragment?t.children:[t]]),[])}return t.reduce(((t,a)=>{const r=e[a];return r&&(t[a]=r()),t}),{})}function getFragmentableTag(e){return Fragment}const Translation={name:"i18n-t",props:assign({keypath:{type:String,required:!0},plural:{type:[Number,String],validator:e=>isNumber(e)||!isNaN(e)}},baseFormatProps),setup(e,t){const{slots:a,attrs:r}=t,n=e.i18n||useI18n({useScope:e.scope,__useComponent:!0});return()=>{const l=Object.keys(a).filter((e=>"_"!==e)),s={};e.locale&&(s.locale=e.locale),void 0!==e.plural&&(s.plural=isString(e.plural)?+e.plural:e.plural);const o=getInterpolateArg(t,l),i=n[TransrateVNodeSymbol](e.keypath,o,s),c=assign({},r),u=isString(e.tag)||isObject(e.tag)?e.tag:getFragmentableTag();return h(u,c,i)}}};function isVNode(e){return isArray(e)&&!isString(e[0])}function renderFormatter(e,t,a,r){const{slots:n,attrs:l}=t;return()=>{const t={part:!0};let s={};e.locale&&(t.locale=e.locale),isString(e.format)?t.key=e.format:isObject(e.format)&&(isString(e.format.key)&&(t.key=e.format.key),s=Object.keys(e.format).reduce(((t,r)=>a.includes(r)?assign({},t,{[r]:e.format[r]}):t),{}));const o=r(e.value,t,s);let i=[t.key];isArray(o)?i=o.map(((e,t)=>{const a=n[e.type],r=a?a({[e.type]:e.value,index:t,parts:o}):[e.value];return isVNode(r)&&(r[0].key=`${e.type}-${t}`),r})):isString(o)&&(i=[o]);const c=assign({},l),u=isString(e.tag)||isObject(e.tag)?e.tag:getFragmentableTag();return h(u,c,i)}}const NumberFormat={name:"i18n-n",props:assign({value:{type:Number,required:!0},format:{type:[String,Object]}},baseFormatProps),setup(e,t){const a=e.i18n||useI18n({useScope:"parent",__useComponent:!0});return renderFormatter(e,t,NUMBER_FORMAT_OPTIONS_KEYS,((...e)=>a[NumberPartsSymbol](...e)))}},DatetimeFormat={name:"i18n-d",props:assign({value:{type:[Number,Date],required:!0},format:{type:[String,Object]}},baseFormatProps),setup(e,t){const a=e.i18n||useI18n({useScope:"parent",__useComponent:!0});return renderFormatter(e,t,DATETIME_FORMAT_OPTIONS_KEYS,((...e)=>a[DatetimePartsSymbol](...e)))}};function getComposer$1(e,t){const a=e;if("composition"===e.mode)return a.__getInstance(t)||e.global;{const r=a.__getInstance(t);return null!=r?r.__composer:e.global.__composer}}function vTDirective(e){const t=t=>{const{instance:a,modifiers:r,value:n}=t;if(!a||!a.$)throw Error(I18nErrorCodes.UNEXPECTED_ERROR);const l=getComposer$1(e,a.$),s=parseValue(n);return[Reflect.apply(l.t,l,[...makeParams(s)]),l]};return{created:(a,r)=>{const[n,l]=t(r);inBrowser&&e.global===l&&(a.__i18nWatcher=watch(l.locale,(()=>{r.instance&&r.instance.$forceUpdate()}))),a.__composer=l,a.textContent=n},unmounted:e=>{inBrowser&&e.__i18nWatcher&&(e.__i18nWatcher(),e.__i18nWatcher=void 0,delete e.__i18nWatcher),e.__composer&&(e.__composer=void 0,delete e.__composer)},beforeUpdate:(e,{value:t})=>{if(e.__composer){const a=e.__composer,r=parseValue(t);e.textContent=Reflect.apply(a.t,a,[...makeParams(r)])}},getSSRProps:e=>{const[a]=t(e);return{textContent:a}}}}function parseValue(e){if(isString(e))return{path:e};if(isPlainObject(e)){if(!("path"in e))throw Error(I18nErrorCodes.REQUIRED_VALUE,"path");return e}throw Error(I18nErrorCodes.INVALID_VALUE)}function makeParams(e){const{path:t,locale:a,args:r,choice:n,plural:l}=e,s={},o=r||{};return isString(a)&&(s.locale=a),isNumber(n)&&(s.plural=n),isNumber(l)&&(s.plural=l),[t,o,s]}function apply(e,t,...a){const r=isPlainObject(a[0])?a[0]:{},n=!!r.useI18nComponentName;(!isBoolean(r.globalInstall)||r.globalInstall)&&(e.component(n?"i18n":Translation.name,Translation),e.component(NumberFormat.name,NumberFormat),e.component(DatetimeFormat.name,DatetimeFormat)),e.directive("t",vTDirective(t))}function defineMixin(e,t,a){return{beforeCreate(){const r=getCurrentInstance();if(!r)throw Error(I18nErrorCodes.UNEXPECTED_ERROR);const n=this.$options;if(n.i18n){const a=n.i18n;n.__i18n&&(a.__i18n=n.__i18n),a.__root=t,this===this.$root?this.$i18n=mergeToRoot(e,a):(a.__injectWithOption=!0,this.$i18n=createVueI18n(a))}else n.__i18n?this===this.$root?this.$i18n=mergeToRoot(e,n):this.$i18n=createVueI18n({__i18n:n.__i18n,__injectWithOption:!0,__root:t}):this.$i18n=e;n.__i18nGlobal&&adjustI18nResources(t,n,n),e.__onComponentInstanceCreated(this.$i18n),a.__setInstance(r,this.$i18n),this.$t=(...e)=>this.$i18n.t(...e),this.$rt=(...e)=>this.$i18n.rt(...e),this.$tc=(...e)=>this.$i18n.tc(...e),this.$te=(e,t)=>this.$i18n.te(e,t),this.$d=(...e)=>this.$i18n.d(...e),this.$n=(...e)=>this.$i18n.n(...e),this.$tm=e=>this.$i18n.tm(e)},mounted(){},unmounted(){const e=getCurrentInstance();if(!e)throw Error(I18nErrorCodes.UNEXPECTED_ERROR);delete this.$t,delete this.$rt,delete this.$tc,delete this.$te,delete this.$d,delete this.$n,delete this.$tm,a.__deleteInstance(e),delete this.$i18n}}}function mergeToRoot(e,t){e.locale=t.locale||e.locale,e.fallbackLocale=t.fallbackLocale||e.fallbackLocale,e.missing=t.missing||e.missing,e.silentTranslationWarn=t.silentTranslationWarn||e.silentFallbackWarn,e.silentFallbackWarn=t.silentFallbackWarn||e.silentFallbackWarn,e.formatFallbackMessages=t.formatFallbackMessages||e.formatFallbackMessages,e.postTranslation=t.postTranslation||e.postTranslation,e.warnHtmlInMessage=t.warnHtmlInMessage||e.warnHtmlInMessage,e.escapeParameterHtml=t.escapeParameterHtml||e.escapeParameterHtml,e.sync=t.sync||e.sync,e.__composer[SetPluralRulesSymbol](t.pluralizationRules||e.pluralizationRules);const a=getLocaleMessages(e.locale,{messages:t.messages,__i18n:t.__i18n});return Object.keys(a).forEach((t=>e.mergeLocaleMessage(t,a[t]))),t.datetimeFormats&&Object.keys(t.datetimeFormats).forEach((a=>e.mergeDateTimeFormat(a,t.datetimeFormats[a]))),t.numberFormats&&Object.keys(t.numberFormats).forEach((a=>e.mergeNumberFormat(a,t.numberFormats[a]))),e}const I18nInjectionKey=makeSymbol("global-vue-i18n");function createI18n(e={},t){const a=!isBoolean(e.legacy)||e.legacy,r=!isBoolean(e.globalInjection)||e.globalInjection,n=!a||!!e.allowComposition,l=new Map,[s,o]=createGlobal(e,a),i=makeSymbol("");{const e={get mode(){return a?"legacy":"composition"},get allowComposition(){return n},async install(t,...n){t.__VUE_I18N_SYMBOL__=i,t.provide(t.__VUE_I18N_SYMBOL__,e),!a&&r&&injectGlobalFields(t,e.global),apply(t,e,...n),a&&t.mixin(defineMixin(o,o.__composer,e));const l=t.unmount;t.unmount=()=>{e.dispose(),l()}},get global(){return o},dispose(){s.stop()},__instances:l,__getInstance:function(e){return l.get(e)||null},__setInstance:function(e,t){l.set(e,t)},__deleteInstance:function(e){l.delete(e)}};return e}}function useI18n(e={}){const t=getCurrentInstance();if(null==t)throw Error(I18nErrorCodes.MUST_BE_CALL_SETUP_TOP);if(!t.isCE&&null!=t.appContext.app&&!t.appContext.app.__VUE_I18N_SYMBOL__)throw Error(I18nErrorCodes.NOT_INSLALLED);const a=getI18nInstance(t),r=getGlobalComposer(a),n=getComponentOptions(t),l=getScope(e,n);if("legacy"===a.mode&&!e.__useComponent){if(!a.allowComposition)throw Error(I18nErrorCodes.NOT_AVAILABLE_IN_LEGACY_MODE);return useI18nForLegacy(t,l,r,e)}if("global"===l)return adjustI18nResources(r,e,n),r;if("parent"===l){let n=getComposer(a,t,e.__useComponent);return null==n&&(n=r),n}const s=a;let o=s.__getInstance(t);if(null==o){const a=assign({},e);"__i18n"in n&&(a.__i18n=n.__i18n),r&&(a.__root=r),o=createComposer(a),setupLifeCycle(s,t),s.__setInstance(t,o)}return o}const castToVueI18n=e=>{if(!(__VUE_I18N_BRIDGE__ in e))throw Error(I18nErrorCodes.NOT_COMPATIBLE_LEGACY_VUE_I18N);return e};function createGlobal(e,t,a){const r=effectScope();{const a=t?r.run((()=>createVueI18n(e))):r.run((()=>createComposer(e)));if(null==a)throw Error(I18nErrorCodes.UNEXPECTED_ERROR);return[r,a]}}function getI18nInstance(e){{const t=inject(e.isCE?I18nInjectionKey:e.appContext.app.__VUE_I18N_SYMBOL__);if(!t)throw createI18nError(e.isCE?I18nErrorCodes.NOT_INSLALLED_WITH_PROVIDE:I18nErrorCodes.UNEXPECTED_ERROR);return t}}function getScope(e,t){return isEmptyObject(e)?"__i18n"in t?"local":"global":e.useScope?e.useScope:"local"}function getGlobalComposer(e){return"composition"===e.mode?e.global:e.global.__composer}function getComposer(e,t,a=!1){let r=null;const n=t.root;let l=t.parent;for(;null!=l;){const t=e;if("composition"===e.mode)r=t.__getInstance(l);else{const e=t.__getInstance(l);null!=e&&(r=e.__composer,a&&r&&!r[InejctWithOption]&&(r=null))}if(null!=r)break;if(n===l)break;l=l.parent}return r}function setupLifeCycle(e,t,a){onMounted((()=>{}),t),onUnmounted((()=>{e.__deleteInstance(t)}),t)}function useI18nForLegacy(e,t,a,r={}){const n="local"===t,l=shallowRef(null);if(n&&e.proxy&&!e.proxy.$options.i18n&&!e.proxy.$options.__i18n)throw Error(I18nErrorCodes.MUST_DEFINE_I18N_OPTION_IN_ALLOW_COMPOSITION);const s=!isBoolean(r.inheritLocale)||r.inheritLocale,o=ref(n&&s?a.locale.value:isString(r.locale)?r.locale:DEFAULT_LOCALE),i=ref(n&&s?a.fallbackLocale.value:isString(r.fallbackLocale)||isArray(r.fallbackLocale)||isPlainObject(r.fallbackLocale)||!1===r.fallbackLocale?r.fallbackLocale:o.value),c=ref(getLocaleMessages(o.value,r)),u=ref(isPlainObject(r.datetimeFormats)?r.datetimeFormats:{[o.value]:{}}),m=ref(isPlainObject(r.numberFormats)?r.numberFormats:{[o.value]:{}}),g=n?a.missingWarn:!isBoolean(r.missingWarn)&&!isRegExp(r.missingWarn)||r.missingWarn,f=n?a.fallbackWarn:!isBoolean(r.fallbackWarn)&&!isRegExp(r.fallbackWarn)||r.fallbackWarn,p=n?a.fallbackRoot:!isBoolean(r.fallbackRoot)||r.fallbackRoot,_=!!r.fallbackFormat,b=isFunction(r.missing)?r.missing:null,d=isFunction(r.postTranslation)?r.postTranslation:null,E=n?a.warnHtmlMessage:!isBoolean(r.warnHtmlMessage)||r.warnHtmlMessage,v=!!r.escapeParameter,O=n?a.modifiers:isPlainObject(r.modifiers)?r.modifiers:{},F=r.pluralRules||n&&a.pluralRules;function I(e){return o.value,i.value,c.value,u.value,m.value,e()}const N={get id(){return l.value?l.value.id:-1},locale:computed({get:()=>l.value?l.value.locale.value:o.value,set:e=>{l.value&&(l.value.locale.value=e),o.value=e}}),fallbackLocale:computed({get:()=>l.value?l.value.fallbackLocale.value:i.value,set:e=>{l.value&&(l.value.fallbackLocale.value=e),i.value=e}}),messages:computed((()=>l.value?l.value.messages.value:c.value)),datetimeFormats:computed((()=>u.value)),numberFormats:computed((()=>m.value)),get inheritLocale(){return l.value?l.value.inheritLocale:s},set inheritLocale(e){l.value&&(l.value.inheritLocale=e)},get availableLocales(){return l.value?l.value.availableLocales:Object.keys(c.value)},get modifiers(){return l.value?l.value.modifiers:O},get pluralRules(){return l.value?l.value.pluralRules:F},get isGlobal(){return!!l.value&&l.value.isGlobal},get missingWarn(){return l.value?l.value.missingWarn:g},set missingWarn(e){l.value&&(l.value.missingWarn=e)},get fallbackWarn(){return l.value?l.value.fallbackWarn:f},set fallbackWarn(e){l.value&&(l.value.missingWarn=e)},get fallbackRoot(){return l.value?l.value.fallbackRoot:p},set fallbackRoot(e){l.value&&(l.value.fallbackRoot=e)},get fallbackFormat(){return l.value?l.value.fallbackFormat:_},set fallbackFormat(e){l.value&&(l.value.fallbackFormat=e)},get warnHtmlMessage(){return l.value?l.value.warnHtmlMessage:E},set warnHtmlMessage(e){l.value&&(l.value.warnHtmlMessage=e)},get escapeParameter(){return l.value?l.value.escapeParameter:v},set escapeParameter(e){l.value&&(l.value.escapeParameter=e)},t:function(...e){return l.value?I((()=>Reflect.apply(l.value.t,null,[...e]))):I((()=>""))},getPostTranslationHandler:function(){return l.value?l.value.getPostTranslationHandler():d},setPostTranslationHandler:function(e){l.value&&l.value.setPostTranslationHandler(e)},getMissingHandler:function(){return l.value?l.value.getMissingHandler():b},setMissingHandler:function(e){l.value&&l.value.setMissingHandler(e)},rt:function(...e){return l.value?Reflect.apply(l.value.rt,null,[...e]):""},d:function(...e){return l.value?I((()=>Reflect.apply(l.value.d,null,[...e]))):I((()=>""))},n:function(...e){return l.value?I((()=>Reflect.apply(l.value.n,null,[...e]))):I((()=>""))},tm:function(e){return l.value?l.value.tm(e):{}},te:function(e,t){return!!l.value&&l.value.te(e,t)},getLocaleMessage:function(e){return l.value?l.value.getLocaleMessage(e):{}},setLocaleMessage:function(e,t){l.value&&(l.value.setLocaleMessage(e,t),c.value[e]=t)},mergeLocaleMessage:function(e,t){l.value&&l.value.mergeLocaleMessage(e,t)},getDateTimeFormat:function(e){return l.value?l.value.getDateTimeFormat(e):{}},setDateTimeFormat:function(e,t){l.value&&(l.value.setDateTimeFormat(e,t),u.value[e]=t)},mergeDateTimeFormat:function(e,t){l.value&&l.value.mergeDateTimeFormat(e,t)},getNumberFormat:function(e){return l.value?l.value.getNumberFormat(e):{}},setNumberFormat:function(e,t){l.value&&(l.value.setNumberFormat(e,t),m.value[e]=t)},mergeNumberFormat:function(e,t){l.value&&l.value.mergeNumberFormat(e,t)}};return onBeforeMount((()=>{if(null==e.proxy||null==e.proxy.$i18n)throw Error(I18nErrorCodes.NOT_AVAILABLE_COMPOSITION_IN_LEGACY);const a=l.value=e.proxy.$i18n.__composer;"global"===t?(o.value=a.locale.value,i.value=a.fallbackLocale.value,c.value=a.messages.value,u.value=a.datetimeFormats.value,m.value=a.numberFormats.value):n&&function(e){e.locale.value=o.value,e.fallbackLocale.value=i.value,Object.keys(c.value).forEach((t=>{e.mergeLocaleMessage(t,c.value[t])})),Object.keys(u.value).forEach((t=>{e.mergeDateTimeFormat(t,u.value[t])})),Object.keys(m.value).forEach((t=>{e.mergeNumberFormat(t,m.value[t])})),e.escapeParameter=v,e.fallbackFormat=_,e.fallbackRoot=p,e.fallbackWarn=f,e.missingWarn=g,e.warnHtmlMessage=E}(a)})),N}const globalExportProps=["locale","fallbackLocale","availableLocales"],globalExportMethods=["t","rt","d","n","tm"];function injectGlobalFields(e,t){const a=Object.create(null);globalExportProps.forEach((e=>{const r=Object.getOwnPropertyDescriptor(t,e);if(!r)throw Error(I18nErrorCodes.UNEXPECTED_ERROR);const n=isRef(r.value)?{get:()=>r.value.value,set(e){r.value.value=e}}:{get:()=>r.get&&r.get()};Object.defineProperty(a,e,n)})),e.config.globalProperties.$i18n=a,globalExportMethods.forEach((a=>{const r=Object.getOwnPropertyDescriptor(t,a);if(!r||!r.value)throw Error(I18nErrorCodes.UNEXPECTED_ERROR);Object.defineProperty(e.config.globalProperties,`$${a}`,r)}))}registerMessageResolver(resolveValue),registerLocaleFallbacker(fallbackWithLocaleChain);export{DatetimeFormat,I18nInjectionKey,NumberFormat,Translation,VERSION,castToVueI18n,createI18n,useI18n,vTDirective};
